import semver from 'semver';
import type { HeftConfiguration } from '@rushstack/heft';
import type { ITerminal } from '@rushstack/terminal';
import type { IBaseTypeScriptTool } from './TypeScriptBuilder';
/**
 * @internal
 */
export interface ILoadedTypeScriptTool {
    tool: IBaseTypeScriptTool;
    typescriptVersion: string;
    typescriptParsedVersion: semver.SemVer;
    capabilities: ICompilerCapabilities;
}
/**
 * @internal
 */
export interface ICompilerCapabilities {
    /**
     * Support for incremental compilation via `ts.createIncrementalProgram()`.
     * Introduced with TypeScript 3.6.
     */
    incrementalProgram: boolean;
    /**
     * Support for composite projects via `ts.createSolutionBuilder()`.
     * Introduced with TypeScript 3.0.
     */
    solutionBuilder: boolean;
}
/**
 * @internal
 */
export interface ILoadTypeScriptToolOptions {
    terminal: ITerminal;
    heftConfiguration: HeftConfiguration;
    onlyResolveSymlinksInNodeModules?: boolean;
    buildProjectReferences?: boolean;
}
/**
 * @internal
 */
export declare function loadTypeScriptToolAsync(options: ILoadTypeScriptToolOptions): Promise<ILoadedTypeScriptTool>;
//# sourceMappingURL=loadTypeScriptTool.d.ts.map